aboutsummaryrefslogtreecommitdiff
path: root/bin/d2u.sh
diff options
context:
space:
mode:
authorTom Ryder <tom@sanctum.geek.nz>2017-04-05 20:06:39 +1200
committerTom Ryder <tom@sanctum.geek.nz>2017-04-05 20:46:47 +1200
commitc8ab406749124d2e762ad5cf53963070113afd0f (patch)
tree54c9721a06957ebe7098a211eea803b0230c0f5d /bin/d2u.sh
parentHandle POSIX correctness in ~/.bash_profile (diff)
downloaddotfiles-c8ab406749124d2e762ad5cf53963070113afd0f.tar.gz
dotfiles-c8ab406749124d2e762ad5cf53963070113afd0f.zip
Apply runtime shebanging to POSIX shell
Diffstat (limited to 'bin/d2u.sh')
-rw-r--r--bin/d2u.sh25
1 files changed, 25 insertions, 0 deletions
diff --git a/bin/d2u.sh b/bin/d2u.sh
new file mode 100644
index 00000000..22c8e16b
--- /dev/null
+++ b/bin/d2u.sh
@@ -0,0 +1,25 @@
+# Convert DOS line endings to UNIX ones
+
+# Check arguments
+if [ "$#" -eq 0 ] ; then
+ printf >&2 'd2u: Need a filename\n'
+ exit 2
+fi
+
+# Put a carriage return into a variable for convenience
+r=$(printf '\r')
+
+# Iterate over arguments and apply the same ed(1) script to each of them
+for fn ; do
+
+ # Note the heredoc WORD is intentionally unquoted because we want to expand
+ # $r within it to get a literal carriage return; the escape characters
+ # prescribed for ed(1) by POSIX are very limited
+ ed -s -- "$fn" <<EOF || ex=1
+g/$r\$/ s/$r\$//
+w
+EOF
+done
+
+# If any of the ed(1) commands failed, we should exit with 1
+exit "${ex:-0}"